<?php

namespace FiloBlu\ExtAmastyXnotif\Plugin\Amasty\Xnotif\Model;

/**
 * Class Observer
 * @package FiloBlu\ExtAmastyXnotif\Plugin\Amasty\Xnotif\Model
 */
class Observer
{
    /**
     * @var \FiloBlu\ExtAmastyXnotif\Helper\Data
     */
    protected $helperData;

    /**
     * Observer constructor.
     * @param \FiloBlu\ExtAmastyXnotif\Helper\Data $helperData
     */
    public function __construct(
        \FiloBlu\ExtAmastyXnotif\Helper\Data $helperData
    )
    {
        $this->helperData = $helperData;
    }

    /**
     * @param \Amasty\Xnotif\Model\Observer $subject
     * @param $product
     * @param $productId
     * @param $storeId
     * @return false
     * Keep this plugin compatible with Magento 2.1
     */
    public function afterLoadProduct($subject,$result)
    {
        $product=$result;
        if ($product === false){
            return $product;
        }
        $storeId = $product->getStoreId();
        //https://filoblu.atlassian.net/browse/FOS-977
        $isGloballySalable = $this->helperData->getGlobalSalability($product,$storeId);
        if ($isGloballySalable){
            return $product;
        }
        return false;
    }
}
